aboutsummaryrefslogtreecommitdiffstats
path: root/util/hpcReport.sh
diff options
context:
space:
mode:
Diffstat (limited to 'util/hpcReport.sh')
-rwxr-xr-xutil/hpcReport.sh30
1 files changed, 20 insertions, 10 deletions
diff --git a/util/hpcReport.sh b/util/hpcReport.sh
index 9348a46..67252cf 100755
--- a/util/hpcReport.sh
+++ b/util/hpcReport.sh
@@ -1,6 +1,8 @@
#!/bin/bash
-if [ ! -e xmonad.cabal ]; then
+set -e
+
+if [[ ! ( -e xmonad.cabal && -e dist/hpc/tix/properties/properties.tix ) ]]; then
echo "run in the same dir as xmonad.cabal after having run
cabal configure --enable-tests --enable-library-coverage; cabal test
@@ -9,12 +11,20 @@ if [ ! -e xmonad.cabal ]; then
exit 1
fi
-for action in markup report; do
- hpc $action \
- --exclude=Instances \
- --exclude=Utils \
- --exclude=Main \
- $(find tests/Properties -name '*.hs' | sed -e 's_/_._g' -e 's_.hs$__' -e 's_^tests._--exclude=_' ) \
- --hpcdir=dist/hpc/mix/xmonad-0.12/ \
- dist/hpc/tix/properties/properties.tix
-done
+
+propsExclude=$(find tests/Properties -name '*.hs' \
+ | sed -e 's_/_._g' -e 's_.hs$__' -e 's_^tests._--exclude=_' )
+
+hpcFlags="
+ --exclude=Instances
+ --exclude=Utils
+ --exclude=Main
+ $propsExclude
+ --hpcdir=dist/hpc/mix/xmonad-0.12/
+ dist/hpc/tix/properties/properties.tix
+ "
+
+hpc markup --destdir=dist/hpc $hpcFlags > /dev/null
+echo "see dist/hpc/hpc_index.html
+"
+hpc report $hpcFlags